#include <stdio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/termio.h>
#include "/user/hn/h/standard.h"

char *progname;

char place[81][81], neighbours[81][81];
int generation=0, r_off=40-12, k_off=40-20, row = 40-12, col = 40-20;

main(argc, argv)
int argc;
char **argv;
{
    register int r, k;
    register char c;
    register char *prev, *curr, *next;

    progname = argv[0];
    sterm(ON);
    printf("\033[2J");
    pr_scr();
    while (TRUE) {
	printf("\033[3;50HRow %d Col %d", row, col);
	printf("\033[4;50HR_off %d K_off %d", r_off, k_off);
	printf("\033[%d;%dH", row - r_off + 1, col - k_off + 1);
	c = '[';
	switch(uppercase(getchar())) {
	    case 'I':
		putchar((place[row][col] = !place[row][col]) ? '#' : '.');
		generation = 0;
		printf("\033[0;50HGeneration %d    ", generation);
		break;
	    case 'E':
		for (r = 1; r < 81; r++)
		    for (k = 1; k < 81; k++)
			place[r][k] = FALSE;
		generation = 0;
		pr_scr();
		break;
	    case 'S':
		for (r = 1; r < 81; r++) {
		    prev = place[r-1]; curr = place[r]; next = place[r+1];
		    for (k = 1; k < 81; k++)
			neighbours[r][k] = prev[k-1] + prev[k] + prev[k+1]
					 + curr[k-1]           + curr[k+1]
					 + next[k-1] + next[k] + next[k+1];
		    }
		for (r = 1; r < 81; r++)
		    for (k = 1; k < 81; k++)
			if ((c = neighbours[r][k]) < 2  OR  c > 3)
			    place[r][k] = FALSE;
			else if (c == 3)
			    place[r][k] = TRUE;
		pr_scr();
		generation++;
		break;
	    case '?':
		goto help;
	    case CTRL_P:
		goto up;
	    case CTRL_N:
		goto down;
	    case CTRL_B:
		goto left;
	    case CTRL_F:
		goto right;
	    case ESC:
		if ((c = getchar()) == '['  OR  c == 'O') {
		    switch(getchar()) {
			case 'A':
up:			    row--;
			    if (row < r_off) row = r_off;
			    break;
			case 'B':
down:			    row++;
			    if (row > r_off + 23) row = r_off + 23;
			    break;
			case 'C':
right:			    col++;
			    if (col > k_off + 40) col = k_off + 40;
			    break;
			case 'D':
left:			    col--;
			    if (col < k_off) col = k_off;
			    break;
			case 'I':
help:			    printf("\033[2J\033[H");
			    printf("I = invertera punkten\n");
			    printf("E = Sudda hela\n");
			    printf("S = Stega fram}t en generation\n");
			    printf("Q = Avsluta\n");
			    printf("Paddan eller CTRL-P, CTRL-N, CTRL-B och");
			    printf(" CTRL-F  f|r att g} omkring\n");
			    printf("SHIFT+Padda = g} och invertera den du ");
			    printf("kommer till\n");
			    printf("HELP eller ? ger denna hj{lptext\n");
			    printf("\n8 = Skifta ett steg upp}t\n");
			    printf("2 = Skifta ett steg ned}t\n");
			    printf("4 = Skifta ett steg }t v{nster\n");
			    printf("6 = Skifta ett steg }t h|ger\n");
			    printf("CTRL-L = Skriv om sk{rmen\n");
			    printf("\nTryck p} en tangent f|r att forts{tta:");
			    getchar();
			    printf("\033[2J");
			    pr_scr();
			default:
			    c = '[';
			    break;
			}
		    if (c == 'O') {
			printf("\033[%d;%dH", row-r_off+1, col-k_off+1);
			putchar((place[row][col] = !place[row][col])
				 ? '#' : '.');
			generation = 0;
			printf("\033[0;50HGeneration %d    ", generation);
			}
		    }
		break;
	    case '8':
/*		for (r = 1; r < 80; r++)
		    for (k = 1; k < 80; k++)
			place[r][k] = place[r+1][k];
		for (k = 1; k < 80; k++)
		    place[80][k] = FALSE;*/
		if (r_off == 80 - 24 + 1)
		    break;
		r_off++;
		row--;
		pr_scr();
		break;
	    case '2':
/*		for (r = 80; r > 1; r--)
		    for (k = 1; k < 80; k++)
			place[r][k] = place[r-1][k];
		for (k = 1; k < 80; k++)
		    place[1][k] = FALSE;*/
		if (r_off == 1)
		    break;
		r_off--;
		row++;
		pr_scr();
		break;
	    case '4':
/*		for (r = 1; r < 80; r++) {
		    for (k = 1; k < 80; k++)
			place[r][k] = place[r][k+1];
		    place[r][80] = FALSE;
		    }*/
		if (k_off == 80 - 24 + 1)
		    break;
		k_off++;
		col--;
		pr_scr();
		break;
	    case '6':
/*		for (r = 1; r < 80; r++) {
		    for (k = 80; k > 1; k--)
			place[r][k] = place[r][k-1];
		    place[r][1] = FALSE;
		    }*/
		if (k_off == 1)
		    break;
		k_off--;
		col++;
	    case CTRL_L:
		pr_scr();
		break;
	    case 'Q':
	    case CTRL_C:
	    case CTRL_D:
	    case CTRL_G:
		goto end;
	    default:
		break;
	    }
	}
end:
    printf("\033[24;0H\n");
    sterm(OFF);
}

/*** Pr_scr() redraws the screen ***/
pr_scr()
{
    register int r, k;

    printf("\033[H");
    for (r = r_off; r < r_off + 24; r++) {
	for (k = k_off; k < k_off + 40; k++)
	    pr_char(place[r][k] ? '#' : '.');
	pr_char('0' + r / 10);pr_char('0' + r % 10);
	if (r != r_off + 23)
	    pr_char('\n');
	}
    dump();

    printf("\033[0;50HGeneration %d    ", generation);
}

uppercase(c)
char c;
{
    return (c >= 'a' AND c <= '}' ? c - 'a' + 'A' : c);
}

char outbuf[4096], *outbufp = outbuf;

pr_char(c)
char c;
{
    if (outbufp - outbuf >= 4096)
	dump();
    *outbufp++ = c;
}

dump()
{
    write(STDOUT, outbuf, outbufp - outbuf);
    outbufp = outbuf;
}

/***    sterm(ON)       set special mode
        sterm(OFF)      reset to normal mode
*/
sterm(n) int n;
{
    struct termio tty;

    ioctl(STDIN, TCGETA, &tty);

    /* immediate action lflag:ICANON
       no echo          lflag:ECHO
       no signals       lflag:ISIG

       no stop/start    iflag:IXON
    */

    if (n == ON) {
        ResBit(tty.c_lflag, ICANON | ECHO);
        ResBit(tty.c_iflag, IXON);
        }
    else {
        SetBit(tty.c_lflag, ICANON | ECHO);
        SetBit(tty.c_iflag, IXON);
        }
    ioctl(STDIN, TCSETA, &tty);
}

panic(text, arg)
char *text, *arg;
{
    fprintf(stderr, "%s: ", progname);
    fprintf(stderr, text, arg);
    putc('\n', stderr);
    exit(1);
}
