#include         <stdio.h>
#include         <signal.h>
#include	 <sys/types.h>
#include	 <sys/ioctl.h>
#include	 <sys/termio.h>
#include	 "standard.h" /* or ../h/standard.h or whatever it's called */

/*** Set_sig() sets the following signals:
	QUIT is set to ctrl_G()
	INTERRUPT is ignored (So that siv doesn't stop when
		INTERRUPT is sent to a subshell)
	HANGUP is set to hangup_catch(), so that siv can save the
		buffers when it gets a hangup.
	***/
set_sig(n)
register int n;
{
    int ctrl_G();
    int hangup_catch();
    static int (*sigint)(), (*sigquit)(), (*sighup)();

    if (n == ON) {
	sigint = signal(SIGINT, SIG_IGN);
	sigquit = signal(SIGQUIT, ctrl_G);
	sighup = signal(SIGHUP, hangup_catch);
	}
    else {
	signal(SIGINT, sigint);
	signal(SIGQUIT, sigquit);
	signal(SIGHUP, sighup);
	}
}

/*** Ctrl_G() catches CTRL_G ***/
ctrl_G()
{
    signal(SIGQUIT, SIG_IGN);
    if (NOT ctrl_Q_flag) {
	m_arg = u_arg = 0;
	m_ = macrlen;
	aborted = TRUE;
	}
    signal(SIGQUIT, ctrl_G);
}

/***********************************************************
Sterm(ON)	Sets terminal in RAW mode
Sterm(OFF)	Sets terminal in normal mode
***********************************************************/

sterm(option)
register int option;
{
    static struct termio tty;
    static char intr, quit;

    ioctl(STDIN, TCGETA, &tty);	/* Get old settings */

    if (option == ON) {		/* RAW mode */
	tty.c_lflag &= ~(ICANON | ECHO | ISIG);
	/* Turns off line processing, echoing and the break and interrupt */
	/* characters */

        tty.c_iflag &= ~(ICRNL | IXON);
	/* Turns off conversion of CR to LF, and XON/XOFF handling */
	}
    else {			/* Normal mode */
	tty.c_lflag |= (ICANON | ECHO | ISIG);
	tty.c_iflag |= (IXON | ICRNL);
	}

    ioctl(STDIN, TCSETA, &tty);	/* Set new values */
}
