#include <stdio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/termio.h>

#define STDIN 0
#define NOT !
#define ERROR -1
#define TRUE 1
#define FALSE 0
#define ON 1
#define OFF 0

#define TOGGLE 10
#define BLANK 12
#define INVERT 24
#define SAVE 19
#define SHOW 22
#define QUIT 3
#define LOAD 1
#define ESCAPE 27
#define UP 'A'
#define DOWN 'B'
#define LEFT 'D'
#define RIGHT 'C'
#define U_R 'a'
#define D_R 'c'
#define D_L 'b'
#define U_L 'd'

char hexdig[]="0123456789abcdef";
char *progname;

main(argc, argv)
int argc;
char *argv[];
{
    FILE *fopen(), *output, *input;
    int i, j, pix[16][16], x, y, a, b, k;
    char c, buf[160];

    progname=argv[0];
    if (argc < 2)
	panic("Usage: bckgrnd file", NULL);
    sterm(ON);
    printf("\033[2J");
    printf("\033[18;0HPiltangenter = upp, ned, h|ger, v{nster.\n");
    printf("SHIFT+Piltangent = F|rflytta och invertera pixeln man kom till\n");
    printf("RETURN = Invertera aktuell pixel\n");
    printf("CTRL_L = Blanka        CTRL_X = Invertera hela m|nstret\n");
    printf("CTRL_S = Spara         CTRL_V = Visa m|nstret\n");
    printf("CTRL_C = Avbryt        CTRL_A = L{s fr}n fil");

    c = BLANK;
    x = y = 0;
    printf("\033[%d;%dH", y+1, x+1);
    while (1) {
	switch(c) {
	    case ESCAPE:
		if ((c=getchar())=='[' || c=='O')
		    switch(getchar()) {
			case UP:
			    if (y>0) y--;
			    break;
			case DOWN:
			    if (y<15) y++;
			    break;
			case LEFT:
			    if (x>0) x--;
			    break;
			case RIGHT:
			    if (x<15) x++;
			    break;
			case U_R:
			    if (y>0 && x<15) { y--; x++; }
			    break;
			case D_R:
			    if (y<15 && x<15) { y++; x++; }
			    break;
			case D_L:
			    if (y<15 && x>0) { y++; x--; }
			    break;
			case U_L:
			    if (y>0 && x>0) { y--; x--; }
			    break;
			}
		if (c=='O')
		    break;
		else
		    printf("\033[%d;%dH", y+1, x+1);
	    case TOGGLE:
		if (pix[x][y] = !pix[x][y])
		    putchar(' ');
		else
		    putchar('#');
		break;
	    case BLANK:
		printf("\033[0;0H");
		for (i=0; i<16; i++) {
		    printf("################!\n");
		    for (j=0; j<16; j++)
			pix[j][i] = 0;
		    }
		printf("----------------+");
		break;
	    case INVERT:
		printf("\033[0;0H");
		for (i=0; i<16; i++) {
		    for (j=0; j<16; j++)
			if (pix[j][i] = !pix[j][i])
			    putchar(' ');
			else
			    putchar('#');
		    putchar('\n');
		    }
		break;
	    case SAVE:
		if ((output=fopen(argv[1], "w")) == NULL)
		    panic("Can't open ", argv[1]);
		fprintf(output, "background1:bmap#");
		for (i=0; i<16; i++) {
		    fprintf(output, "0x");
		    for (j=0; j<16; j+=4)
			putc(hexdig[8*pix[j][i] + 4*pix[j+1][i]
				  + 2*pix[j+2][i] + pix[j+3][i]], output);
		    if (i<15)
			putc(',', output);
		    }
		putc('\n', output);
	    case QUIT:
		printf("\033[23;0H");
		sterm(OFF);
		exit(0);
	    case SHOW:
		for(i=0; i<16; i++)
		    for(j=0; j<16; j++)
			printf("\033:%d;%d;%d;1p", 180+i,
				115-j, pix[i][j]);
		for(i=0; i<16; i++)
		    for (j=0; j<15; j++)
			printf("\033:%d;%d;%d;%d;%d;%d;0r", 180, 100,
				196+i*16, 100+j*16, 16, 16);
		break;
	    case LOAD:
		if ((input=fopen(argv[1], "r")) == NULL) {
		    sterm(OFF);
		    panic("Can't open ", argv[1]);
		    }
		if (fgets(buf, 160, input) == NULL)
		    syntax();
		if (strncmp(buf, "background", 10) != 0)
		    syntax();
		a = 10;
		while (buf[a++] != ':')
		    if (buf[a]=='\0')
			syntax();
		if (strncmp(buf+a, "bmap#0x", 5) != 0)
		    syntax();
		a += 7;
		printf("\033[0;0H");
		for (i=0; i<16; i++) {
		    for (j=0; j<4; j++) {
			for (b=0; b<16 && buf[a+i*7+j]!=hexdig[b]; b++)
			if (b==16)
			    syntax();
			for (k=0; k<4; k++)
			    if (pix[j*4+k][i]=((b >> (3-k)) & 1))
				putchar(' ');
			    else
				putchar('#');
			}
		    putchar('\n');
		    }
		fclose(input);
		break;
	    }
	printf("\033[%d;%dH", y+1, x+1);
	c = getchar();
	}
}

panic(str, arg)
char *str, *arg;
{
    fprintf(stderr, "%s: %s", progname, str);
    if (arg != NULL)
	fprintf(stderr, "%s", str);
    putc('\n', stderr);
    exit(1);
}

syntax()
{
    printf("\033[23;0HSyntax error in input file\n");
    sterm(OFF);
    exit(1);
}

sterm(n) int n;
{
    struct termio tty;          /* new param xfer  */
    static struct termio oldtty;/* keep old params */

    switch(n) {
        case ON:
            ioctl(STDIN,TCGETA,&oldtty);
            tty = oldtty;               /* save old pars */

            /* immediate action lflag:ICANON
               no echo          lflag:ECHO
               no signals       lflag:ISIG

               no stop/start    iflag:IXON
            */

            tty.c_lflag &= ~(ICANON | ECHO);
            tty.c_iflag &= ~(IXON);

            ioctl(STDIN,TCSETA,&tty);
            break;

        case OFF:
            ioctl(STDIN,TCSETA,&oldtty);
            break;
        }
}
