#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "/user/hn/h/standard.h"

char *progname;
int recursive = FALSE, verbose = FALSE;
char path[256];

main(argc, argv)
register int argc;
register char **argv;
{
    struct stat stbuf;
    int dir = FALSE;
    register char **argp;
    register int count = argc;

    progname = *argv++;
    argp = argv;
    while (--count) {
	if (**argp == '-')
	    if (dir)
		usage();	/* switch after directory */
	    else {
		register char *p;

		for (p = *argp + 1; *p; p++)
			switch (*p) {
			case 'r':
			    recursive = TRUE;
			    break;
			case 'v':
			    verbose = TRUE;
			    break;
			default:
			    error("Bad switch '%c'", *p);
			    usage();
			}
	    }
	else
	    dir = TRUE;
	argp++;
    }
    if (dir)
	while (--argc) {
	    if (**argv != '-') {
		strcpy(path, *argv);
		if (stat(path, &stbuf) == ERROR)
		    error("Can't get status for %s", path);
		else if (NOT S_ISDIR(stbuf.st_mode))
		    error("%s is not a directory", path);
		else
		    clean();
	    }
	    argv++;
	}
    else {
	strcpy(path, ".");
	clean();
    }
}

clean()
{
    struct direct dirbuf;
    struct stat stbuf;
    register int fd, i;
    register char *name;

    if (verbose)
	printf("Cleaning %s\n", path);
    if ((fd = open(path, O_RDONLY)) == ERROR)
	error("Can't read directory %s", path);
    strcat(path, "/");
    name = path + strlen(path);
    while (read(fd, (char *) &dirbuf, sizeof(dirbuf)) == sizeof(dirbuf))
	if (dirbuf.d_ino AND strcmp(dirbuf.d_name, ".") != 0
			AND strcmp(dirbuf.d_name, "..") != 0) {
	    strncpy(name, dirbuf.d_name, DIRSIZ);
	    name[DIRSIZ] == '\0';
	    if (stat(path, &stbuf) == ERROR)
		error("Can't get status for %s", path);
	    else if (NOT S_ISDIR(stbuf.st_mode)) {
		if (strcmp(name, "core") == 0 OR strcmp(name, ".siv_file") == 0
				OR strncmp(name, ".emacs", 6) == 0
				OR strncmp(name, "skit", 4) == 0) {
		    if (unlink(path) == ERROR)
			error("Can't unlink %s", path);
		    else if (verbose)
			printf("\t%s\n", path);
		}
		else if (strlen(name) > 4) {
		    register char *ext = name + strlen(name) - 4;

		    if (strcmp(ext, ".BAK") == 0
				OR  strcmp(ext, ".CKP") == 0) {
			if (unlink(path) == ERROR)
			    error("Can't unlink %s", path);
			else if (verbose)
			    printf("\t%s\n", path);
		    }
		}
	    }
	} 
    if (recursive) {
	lseek(fd, 0L, 0);
	while (read(fd, (char *) &dirbuf, sizeof(dirbuf)) == sizeof(dirbuf))
	    if (dirbuf.d_ino AND strcmp(dirbuf.d_name, ".") != 0
			AND strcmp(dirbuf.d_name, "..") != 0) {
	        strncpy(name, dirbuf.d_name, DIRSIZ);
	        name[DIRSIZ] == '\0';
	        if (stat(path, &stbuf) != ERROR AND S_ISDIR(stbuf.st_mode))
		    clean();
	    }
    }
    close(fd);
}

usage()
{
    panic("Usage: %s [-r] [-v] {directory}", progname);
}

panic(text, arg)
char *text, *arg;
{
    error(text, arg);
    exit(1);
}

error(text, arg)
char *text, *arg;
{
    fprintf(stderr, "%s: ", progname);
    fprintf(stderr, text, arg);
    putc('\n', stderr);
}
