#include <stdio.h>
#include <fcntl.h>
#include <errno.h>

#define TRUE 1
#define FALSE 0
#define STDIN 0
#define STDOUT 1
#define ERROR -1
#define NOERROR 0

int infile;

char outbuf[512];
int bufp=0;

char inbuf[512];
int inbp=0;
int bsize=0;

main(argc,argv)
int argc;
char *argv[];
{
    register int c;
    register int i, j, n, a_flag=FALSE, num_flag=FALSE;
    int filename;

    for ( i=1; i<argc; i++ ) {
	if ( strcmp(argv[i], "-") == 0 || *argv[i] != '-' )
	    break;
	for ( j=1; argv[i][j] != '\0'; j++ )
	    switch ( argv[i][j] ) {
		case 'a':
		    a_flag=TRUE;
		    break;
		case 'n':
		    num_flag=TRUE;
		    break;
		default:
		    fprintf(stderr, "Usage: %s [-a] [file]\n", argv[0]);
		    exit(1);
		    }
	}
    filename = argc-i > 1;	/* >1 file */
    while (i<argc) {
	if (filename) {
	    for (j=0; j < (n=strlen(argv[i]))+6; j++)
		print('.');
	    flush();
	    write(STDOUT, "\n.. ", 4);
	    write(STDOUT, argv[i], n);
	    write(STDOUT, " ..\n", 4);
	    for (j=0; j < (n=strlen(argv[i]))+6; j++)
		print('.');
	    print('\n');
	    }
	if (strcmp(argv[i], "-") == 0)
	    infile = STDIN;
	else if ((infile=open(argv[i], O_RDONLY))==ERROR) {
	    fprintf(stderr, "%s: can't open file %s\n", argv[0], argv[i]);
	    exit(1);
	    }
	while ((c=get()) != ERROR)
	    if (a_flag)
		if (c>31 && c<127)
		    print(c);
		else if (c<128) {
		    print('^');
		    print((char) c-'\0'+'@');
		    }
		else
		    goto unprintable;
	    else
		if (c>31 && c<127) {
		    if (c=='\\' && (!a_flag))
			print(c);
		    print(c);
		    }
		else {
unprintable:	    print('\\');
		    if (num_flag) goto numeric;
		    switch (c) {
			case '\n':
			    print('n');
			    break;
			case '\t':
			    print('t');
			    break;
			case '\033':
			    print('e');
			    break;
			case '\b':
			    print('b');
			    break;
			case '\r':
			    print('r');
			    break;
			case '\f':
			    print('f');
			    break;
			default:
numeric:		    print((char) (((c & 192)/64)+'0'));
			    print((char) (((c &  56)/ 8)+'0'));
			    print((char) ( (c &   7)    +'0'));
			}
		    }
	print('\n');
	if (bsize == ERROR)
	    fprintf(stderr, "Error while reading %s", argv[i]);
	i++;
	}
    flush();
}

print(c)
char c;
{
    outbuf[bufp++] = c;
    if (bufp == 512)
	flush();
}

flush()
{
    write(STDOUT, outbuf, bufp);
    bufp=0;
}

get()
{
    if (inbp == bsize)
	if (fillbuf() == ERROR)
	    return (ERROR);
    return (((int) inbuf[inbp++]) & 0377);
}

fillbuf()
{
    bsize = read(infile, inbuf, 512);
    inbp = 0;
    if (bsize <= 0)
	return (ERROR);
    else
	return (NOERROR);
}
